﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CpReportCustomData
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                rptViewer.LocalReport.SubreportProcessing += 
                    new Microsoft.Reporting.WebForms.SubreportProcessingEventHandler(LocalReport_SubreportProcessing);
            }
        }

        void LocalReport_SubreportProcessing(
            object sender, 
            Microsoft.Reporting.WebForms.SubreportProcessingEventArgs e)
        {
            // get empID from the parameters
            int iEmpID = Convert.ToInt32(e.Parameters[0].Values[0]);

            // remove all previously attached Datasources, since we want to attach a
            // new one
            e.DataSources.Clear();

            // Retrieve employeeFamily list based on EmpID
            var employeeFamily = CpReportCustomData.Data.CustomDS.GetAllEmployeeFamily()
                                 .FindAll(element => element.ID == iEmpID);

            // add retrieved dataset or you can call it list to data source
            e.DataSources.Add(new Microsoft.Reporting.WebForms.ReportDataSource()
            {
                Name = "DSEmployeeFamily",
                Value = employeeFamily

            });

        }
    }
}
